<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Edicion de Funciones
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="control_point"
          label="Alta de Funcion"
          to="/membresia/funciones/alta"
        />
      </div>
    </q-toolbar>
    <q-banner rounded class="text-white bg-red q-mb-sm q-mt-sm">
      Mi Rincón, gestiona automáticamente los permisos de los usuarios en base a
      las funciones establecidas en cruz del sur, pero debido a limitaciones al
      momento de exportar los datos de cds, desde Mi Rincon solo podemos
      gestionar 1 función, por esta razón es importante, que si el educador
      tiene más de 1 función, se le asigne mediante este módulo.
    </q-banner>
    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="paginadoGenericoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading :showing="loading" />
        </template>

        <template v-slot:top-left>
          <div class="q-col-gutter-md row">
            <q-input
              dense
              placeholder="Buscar ..."
              v-model="paginadoGenericoStore.filtros.query"
              debounce="300"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>

            <q-btn color="green" flat label="Filtrar" @click="onRequest" />
            <q-btn color="blue" flat label="Reset" @click="onResetFiltros" />
          </div>
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <PersonaDetalle :persona="props.row" />
          </q-td>
        </template>

        <template v-slot:body-cell-funciones="props">
          <q-td :props="props">
            <div v-for="funcion in props.row.funciones" :key="funcion.uuid">
              <div v-if="funcion.origen === 'M'">
                {{ funcion.organismo_full }} |>
                {{ funcion.funcion }}
                <q-btn
                  flat
                  color="red"
                  size="xs"
                  @click="borrarFuncion(funcion.uuid)"
                >
                  <q-icon name="remove_circle_outline" />
                </q-btn>
              </div>
            </div>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <q-btn
              square
              size="sm"
              color="primary"
              icon="person_search"
              label="legajo"
              :to="'/membresia/personas/perfil/' + props.row.uuid"
            >
            </q-btn>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { usePaginadoGenericoStore } from 'src/stores/paginado-generico';
import Loading from 'src/components/Loading.vue';
import PersonaDetalle from 'components/Personas/Detalle.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  { name: 'funciones', label: 'Funciones', field: 'funciones', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading, PersonaDetalle },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const paginadoGenericoStore = usePaginadoGenericoStore();

    onMounted(() => {
      paginadoGenericoStore.$reset();
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      paginadoGenericoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      paginadoGenericoStore.filtroActivado = true;
      paginadoGenericoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/persona/funcion', {
          params: paginadoGenericoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          paginadoGenericoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      paginadoGenericoStore.resetFiltros();
      onRequest();
    }

    function borrarFuncion(uuid: string) {
      api.delete('/api/persona/funcion/', { data: { uuid } });
      onRequest();
    }

    return {
      columnas,
      dataSet,
      paginadoGenericoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
      borrarFuncion,
    };
  },
});
</script>
